package Amazon::REST;
use strict;
use URI;
use LWP::Simple;
use XML::Simple;

my $token = "D16F26JZ1YEJIY";
my $assoc = "bulknews-22";

sub new {
    my($class, %args) = @_;
    bless {
	token => $token,
	assoc => $assoc,
	type  => 'heavy',
	%args,
    }, $class;
}

sub action {
    my($self, $action, @terms) = @_;
    my $url = URI->new("http://xml.amazon.com/onca/xml3");
    $url->query_form_hash({
	'dev-t' => $self->{token},
	t       => $self->{assoc},
	type    => $self->{type},
	f       => 'xml',
	locale  => 'jp',
	page    => 1,
	$action => join(" ", @terms),
    });
    my $xml = LWP::Simple::get($url);
    my $data = XMLin($xml, KeyAttr => 'Details', ForceArray => 1);
    return $data;
}

1;

