package Amazon::REST;
use strict;
use URI;
use URI::QueryParam;
use LWP::Simple;
use XML::Simple;

my $token = "D16F26JZ1YEJIY";
my $assoc = "bulknews-22";

sub new {
    my($class, %args) = @_;
    bless {
	token => $token,  #
	assoc => $assoc,  # #1 
	type  => 'heavy', #
	%args,            #
    }, $class;
}

sub call {
    my($self, $action, @terms) = @_;
    my $url = URI->new("http://xml.amazon.com/onca/xml3"); #
    $url->query_form_hash({                                #
	'dev-t' => $self->{token},                         #
	t       => $self->{assoc},                         #
	type    => $self->{type},                          # #2
	f       => 'xml',                                  #
	locale  => 'jp',                                   #
	page    => 1,                                      #
	$action => join(" ", @terms),                      #
    });                                                    #
    my $xml = LWP::Simple::get($url); #
    my $data = XMLin($xml);           # #3
    return $data;
}

1;

